<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Procedure Symbol Tables</TITLE>
<link href="suif1_45.html" rel=Next>
<link href="suif1_43.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_43.html">previous</A>, <A HREF="suif1_45.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC44" HREF="suif1_toc.html#TOC44">Procedure Symbol Tables</A></H3>
<P>
<A NAME="IDX272"></A>
<A NAME="IDX273"></A>

</P>
<P>
<A NAME="IDX274"></A>
Procedure symbol tables represent the top-level scopes within procedures
and are associated with the <CODE>tree_proc</CODE> objects at the roots of the
abstract syntax trees for the procedures.  See section <A HREF="suif1_19.html#SEC19">Procedure Nodes</A>.
Because the procedure symbol tables provide a superset of the block
symbol table functions, they are implemented by deriving the
<CODE>proc_symtab</CODE> class from the <CODE>block_symtab</CODE> class.  Thus, all
of the <CODE>block_symtab</CODE> methods can also be applied to
<CODE>proc_symtab</CODE> objects.

</P>
<P>
<A NAME="IDX275"></A>
<A NAME="IDX276"></A>
<A NAME="IDX277"></A>
Besides the inherited methods, the procedure symbol tables have some
added features.  Each procedure symbol table contains a list of the
formal parameters for the procedure.  The <CODE>params</CODE> method returns a
pointer to this list.  The entries on this list must be pointers to
symbols for variables that are contained within the procedure symbol
table.  (Formal parameters cannot be global variables or local variables
in inner scopes.)  The symbols are listed in order.  If the function
type for the procedure specifies the parameter types, they should match
the types of the variables on the parameter list.

</P>
<P>
The procedure symbol table also records the next instruction ID number
for the procedure (see section <A HREF="suif1_12.html#SEC12">ID Numbers for Tree Nodes and Instructions</A>).  The <CODE>number_locals</CODE> method
handles the task of assigning ID numbers to the symbols and types in
symbol tables within the procedure (see section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>).

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_43.html">previous</A>, <A HREF="suif1_45.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
